<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "idp_request_log".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "IdpRequestLog".
 *
 * Columns in table "idp_request_log" available as properties of the model,
 * followed by relations of table "idp_request_log" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idp_provision_id
 * @property string $guid
 * @property string $verb
 * @property string $status
 * @property string $date_added
 * @property string $date_updated
 * @property integer $manual_validation_id
 * @property string $request
 * @property string $message
 * @property string $internal_message
 *
 * @property IdpOperationLog[] $idpOperationLogs
 * @property ManualValidation $manualValidation
 * @property IdpProvision $idpProvision
 * @property IdpResultLog[] $idpResultLogs
 */
abstract class BaseIdpRequestLog extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'idp_request_log';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'IdpRequestLog|IdpRequestLogs', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('idp_provision_id, date_added, date_updated', 'required'),
            array('idp_provision_id, manual_validation_id', 'numerical', 'integerOnly'=>true),
            array('guid', 'length', 'max'=>36),
            array('verb', 'length', 'max'=>10),
            array('status', 'length', 'max'=>1),
            array('request, message, internal_message', 'safe'),
            array('guid, verb, status, manual_validation_id, request, message, internal_message', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idp_provision_id, guid, verb, status, date_added, date_updated, manual_validation_id, request, message, internal_message', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'idpOperationLogs' => array(self::HAS_MANY, 'IdpOperationLog', 'idp_request_log_id'),
            'manualValidation' => array(self::BELONGS_TO, 'ManualValidation', 'manual_validation_id'),
            'idpProvision' => array(self::BELONGS_TO, 'IdpProvision', 'idp_provision_id'),
            'idpResultLogs' => array(self::HAS_MANY, 'IdpResultLog', 'idp_request_log_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'idp_provision_id' => null,
            'guid' => Yii::t('app', 'Guid'),
            'verb' => Yii::t('app', 'Verb'),
            'status' => Yii::t('app', 'Status'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'manual_validation_id' => null,
            'request' => Yii::t('app', 'Request'),
            'message' => Yii::t('app', 'Message'),
            'internal_message' => Yii::t('app', 'Internal Message'),
            'idpOperationLogs' => null,
            'manualValidation' => null,
            'idpProvision' => null,
            'idpResultLogs' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idp_provision_id', $this->idp_provision_id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('verb', $this->verb, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('manual_validation_id', $this->manual_validation_id);
        $criteria->compare('request', $this->request, true);
        $criteria->compare('message', $this->message, true);
        $criteria->compare('internal_message', $this->internal_message, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
